# ipptransform(1)

## Name

ipptransform - convert document data to alternate formats

## Synopsis

ipptransform [ --help ] [ -d device-uri ] [ -f output-filename ] [ -i input/format ] [ -m output/format ] [ -o "name=value [... name=value]" ] [ -r resolution[,...,resolution] ] [ -s {flipped|manual-tumble|normal|rotated} ] [ -t type[,...,type] ] [ -v ] filename

## Description

ipptransform converts the input file into the output format and optionally sends the output to a network printer. ipptransform is normally run by ippserver(8) to convert document data for printing.

## Options

The following options are recognized by ipptransform:

--help
  Shows program help.
-d device-uri
  Specifies an output device as a URI. Currently only the "ipp", "ipps", and "socket" URI schemes are supported, for example "socket://10.0.1.42" to send print data to an AppSocket printer at IP address 10.0.1.42.
-i input/format
  Specifies the MIME media type of the input file. Currently the "application/pdf" (PDF) and "image/jpeg" (JPEG) MIME media types are supported.
-m output/format
  Specifies the MIME media type of the output file. Current the "application/vnd.hp-pcl" (HP PCL) and "image/pwg-raster" (PWG Raster) MIME media types are supported.
-o "name=value [... name=value]"
  Specifies one or more named options for the conversion. Currently the "copies", "media", "media-col", "page-ranges", "print-color-mode", "print-quality", "printer-resolution", and "sides" options are supported. See the NAMED OPTIONS section for more information.
-r resolution[,...,resolution]
  Specifies the supported resolutions. Resolutions are of the form "NNNdpi" or "NNNxNNNdpi", for example "300dpi" or "600x300dpi". HP PCL output only supports resolutions of "300dpi" and "600dpi".
-s {flipped|manual-tumble|normal|rotated}
  Specifies the coordinate system for the back side of duplex sheets.
-t type[,...,type]
  Specifies the output color spaces and bit depths, separated by commas. Types include "adobe-rgb_8" and "adobe-rgb_16" for 8-bit and 16-bit AdobeRGB, "black_1" and "black_8" for 1-bit and 8-bit black, "cmyk_8" for 8-bit CMYK, "sgray_1" and "sgray_8" for 1-bit and 8-bit grayscale with a 2.2 gamma correction, and "srgb_8" for 8-bit sRGB color. Run ipptransform with the --help option to see the list of supported color spaces and bit depths.
-v
  Increases the verbosity for any diagnostics.

## Named Options

The following named options are supported:

copies
  Specifies the number of copies to produce.
media
  Specifies the media size as a PWG standardized media size name. For example, US Letter (8.5x11in) is "na_letter_8.5x11in" and ISO A4 is "iso_a4_210x297mm".
media-col
  Specifies the media size as a collection. Both the "media-size" and "media-size-name" members can be used to specify the size. For example, both "media-col={media-size={x-dimension=21000 y-dimension=29700}}" and "media-col={media-size-name=iso_a4_210x297mm}" specify ISO A4 media.
page-ranges
  Selects a single range of pages to print. For example, the value "5-12" selects pages 5 through 12.
print-color-mode
  Specifies the color mode as "auto" (automatic), "monochrome" (grayscale), or "color".
print-quality
  Specifies the print quality with value 3 (draft), 4 (normal), or 5 (high/best).
print-scaling
  Specifies the scaling to use when converting image files. The values "auto", "fit", and "fill" are supported.
printer-resolution
  Specifies the print resolution using one of the supported print resolutions.
sides
  Specifies whether to do 1-sided printing ("one-sided") or 2-sided printing ("two-sided-long-edge" for portrait and "two-sided-short-edge" for landscape).

## Diagnostics

ipptransform sends all messages to the standard error. Each message is prefixed with "ERROR", "INFO", or "DEBUG" depending on the level of verbosity.

## Exit Status

The ipptransform program returns 0 if the input file is converted successfully and 1 otherwise.

## Environment

ipptransform recognizes the following environment variables:

CONTENT_TYPE
  Specifies the MIME media type of the input file.
DEVICE_URI
  Specifies the output device as a URI.
DOCUMENT_NAME
  Specifies the title of the input file.
IPP_xxx
  Specifies the value of the "xxx" Job Template attribute, where "xxx" is converted to uppercase. For example, the "media" Job Template attribute is stored as the "IPP_MEDIA" environment variable.
IPP_xxx_DEFAULT
  Specifies the default value of the corresponding "xxx-default" Printer Description attribute, where "xxx" is converted to uppercase. For example, the "media-default" Printer Description attribute is stored as the "IPP_MEDIA_DEFAULT" environment variable.
IPP_PWG_RASTER_DOCUMENT_RESOLUTION_SUPPORTED
  Lists the supported output resolutions.
IPP_PWG_RASTER_DOCUMENT_SHEET_BACK
  Specifies the coordinate system of the back side of duplex sheets.
IPP_PWG_RASTER_DOCUMENT_TYPE_SUPPORTED
  Lists the supported output color spaces and bit depths.
IPPTRANSFORM_MAX_RASTER
  Specifies the maximum number of bytes to use when generating raster data. The default is 16MB.
OUTPUT_TYPE
  Specifies the MIME media type of the output file.
SERVER_LOGLEVEL
  Specifies the log level (verbosity) as "error", "info", or "debug".

## Examples

Print a PDF file to a PCL printer at 10.0.1.42:

        ipptransform -d socket://10.0.1.42 -m application/vnd.hp-pcl \
            filename.pdf

Print a PDF file to an IPP Everywhere printer at 10.0.1.42:

        ipptransform -d ipp://10.0.1.42/ipp/print -m image/pwg-raster \
            filename.pdf

Convert a JPEG file to sRGB PWG Raster at 600dpi:

        ipptransform -m image/pwg-raster -r 600dpi -t sgray_8,srgb_8 \
            filename.jpg >filename.ras

## See Also

ippdoclint(7), ippserver(8), ipptool(1), ipptransform3d(7)

## Copyright

Copyright © 2016-2019 by the IEEE-ISTO Printer Working Group. Copyright © 2016-2019 by Apple Inc.